/*
** II5.ARC
**
** Models for psychiatric study, monotone observations
**
** April 10, 1998
*/


model=1;

y1=89~13|57~65;
y2=26|49;

y1=11~1|124~88;
y2=7|68;


n=sumc(sumc(y1))+sumc(sumc(y2));

prob1=0;
prob2=0;
h1=0;
h2=0;


proc logl5(param);

local p,q,pp,ll1,ll2,ll;

p=param[1:3];
q=param[4:rows(param)];

if model==1 or model==2;

pp=p[1]~p[2]|p[3]~(1-sumc(p));

elseif model==3;

pp=p[1]~p[2]|p[3]~(1-sumc(p));
q=q';

elseif model==4;

pp=p[1]~p[2]|p[3]~(1-sumc(p));
q=q';
q=exp(q)./(1+exp(q));


endif;

h1=pp.*q;
h2=pp.*(1-q);

prob1=h1;
prob2=sumc(h2');

ll1=sumc(sumc(y1.*ln(prob1)));
ll2=sumc(sumc(y2.*ln(prob2)));

ll=ll1+ll2;

retp(-ll);
endp;


