/*
** II6.ARC
**
** Models for psychiatric study, monotone observations
**
** Overspecified model 4
**
** April 11, 1998
*/


model=4;
sensit=0;

y1=11~1|124~88;
y2=7|68;

y1=89~13|57~65;
y2=26|49;

n=sumc(sumc(y1))+sumc(sumc(y2));

prob1=0;
prob2=0;
h1=0;
h2=0;


proc logl6(param);

local p,q,pp,ll1,ll2,ll,alfa,beta,gam;

p=param[1:3];
q=param[4:rows(param)];

if model==4;

pp=p[1]~p[2]|p[3]~(1-sumc(p));
alfa=q[1];
beta=q[2];
gam=sensit;

q=alfa+beta*(1|0)+gam*(1~0);
q=exp(q)./(1+exp(q));

endif;

h1=pp.*q;
h2=pp.*(1-q);

prob1=h1;
prob2=sumc(h2');

ll1=sumc(sumc(y1.*ln(prob1)));
ll2=sumc(sumc(y2.*ln(prob2)));

ll=ll1+ll2;

retp(-ll);
endp;


